package eu.mhsl.minenet.minigames.instance.game.stateless.types.towerdefense;

import net.minestom.server.coordinate.Point;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.Entity;
import net.minestom.server.entity.EntityType;
import net.minestom.server.entity.Player;
import net.minestom.server.instance.block.Block;
import org.jetbrains.annotations.Nullable;

public class Cursor extends Entity {
    private boolean cursorActive = false;
    private final int reach;

    public Cursor(int reach) {
        super(EntityType.ARMOR_STAND);
        this.setBoundingBox(0,0,0);
        this.reach = reach;
    }

    public void updateCursorPosition(Player player) {
        Point targetPosition = player.getTargetBlockPosition(this.reach);
        this.moveCursorTo(targetPosition);
    }

    private void moveCursorTo(@Nullable Point newTargetBlockPosition) {
        this.setCursorEnabled(true);
        if(newTargetBlockPosition == null) {
            this.setCursorEnabled(false);
            return;
        }
        if(!this.getInstance().getBlock(newTargetBlockPosition).equals(Block.BLACK_WOOL)) this.setCursorEnabled(false);
        if(!this.getInstance().getGame().getAvailableTowers().containsKey(this.getInstance().getPlayer().getItemInMainHand().material())) this.setCursorEnabled(false);
        this.teleport(new Pos(newTargetBlockPosition.add(0.5,1,0.5)));
    }

    private void setCursorEnabled(boolean enabled) {
        this.cursorActive = enabled;
        this.setInvisible(!enabled);
    }

    @Override
    public TowerdefenseRoom getInstance() {
        return (TowerdefenseRoom) super.getInstance();
    }

    public boolean isCursorActive() {
        return this.cursorActive;
    }

    public Block getTargetBlock() {
        return this.getInstance().getBlock(this.getTargetBlockPosition());
    }

    public Pos getTargetBlockPosition() {
        return this.getPosition().sub(0, 0.5, 0);
    }
}
